
from labscript import *
from labscript_devices.PrawnBlaster.labscript_devices import PrawnBlaster
from labscript_devices.NI_DAQmx.labscript_devices import NI_PCI_DIO_32HS
from labscript_devices.NI_DAQmx.labscript_devices import NI_PCI_6713
from labscript_devices.FunctionRunner.labscript_devices import FunctionRunner

PrawnBlaster(name='prawn', com_port='COM4', num_pseudoclocks=1)
#find the COM port and include it here
FunctionRunner(name='watcher')

NI_PCI_6713(name='ni_card_1',parent_device=prawn.clocklines[0],
                        clock_terminal='PFI2', MAX_name='Dev1')
NI_PCI_DIO_32HS(name='DIO_card',parent_device=prawn.clocklines[0],
                        clock_terminal='PFI2', MAX_name='Dev2')

DigitalOut('dig0', DIO_card, 'port0/line0')
DigitalOut('dig1', DIO_card, 'port0/line1')
AnalogOut('Ana1', ni_card_1, 'ao1')
AnalogOut('AnDummy', ni_card_1, 'ao7')

def timed(shot_context,t):
    import runmanager.remote as rm
    rm.set_globals({'t_out':True})
    rm.engage()

watcher.add_function(t='stop',function=timed)

start()
t0=0
t=t0
t+=1e-4
#choose to trigger the wait monitor or timeout the experiment
if t_out==True:
    dig0.go_high(t)
else:
    dig0.go_low(t)
Ana1.constant(t, value=random())
t+=1e-4
#wait for the trigger
t+=wait('wait_0',t=t,timeout=0.01)
#do things after succesfull retriggering
t+=1e-4
dig0.go_high(t)
Ana1.constant(t,value=0.5)
t+=1e-4
dig0.go_low(t)
Ana1.constant(t,value=0)
t+=1e-4
dig0.go_low(t)
t+=1e-4
stop(t)
